﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Threading;
using System.Media;
using CannonPlane.Properties;

namespace CannonPlane
{
    public partial class Form1 : Form
    {
        private Object thislock = new object();
        bool single_stop = true;
        Thread t1;
        int score = 0;
        bool isShot = false;
        bool isShotfe = false;

        public Form1()
        {
            InitializeComponent();
            t1 = new Thread(new ThreadStart(Plane_fly));
            t1.Start();
        }

        private void Form1_KeyPress(object sender, KeyPressEventArgs e)
        {
            int x = pictureBox1.Location.X;
            int y = pictureBox1.Location.Y;
            if (e.KeyChar == 'w')
            {
                pictureBox1.Location = new System.Drawing.Point(x, y - 20);
            }
            else if (e.KeyChar == 's')
            {
                pictureBox1.Location = new System.Drawing.Point(x, y + 20);
            }
            else if (e.KeyChar == 'a')
            {
                pictureBox1.Location = new System.Drawing.Point(x - 20, y);
            }
            else if (e.KeyChar == 'd')
            {
                pictureBox1.Location = new System.Drawing.Point(x + 20, y);
            }

            if (e.KeyChar == 'j')//发射
            {
                Bullet bullet=new Bullet(); ;
                NewBullet(bullet);
                Thread t2 = new Thread(new ParameterizedThreadStart(Shot));
                t2.Start(bullet);

                isShot = true;
                if (label9.Text == string.Empty)
                {
                    label11.Show();
                    t1.Abort();
                }

            }

            //本身碰撞到了
            if ((Math.Abs(pictureBox1.Location.X- pictureBox2.Location.X)<40) && (Math.Abs(pictureBox1.Location.Y - pictureBox2.Location.Y) < 40))
            {
                SoundPlayer player = new SoundPlayer(Resources.boom);
                player.Play();
                label1.Show();
                score = 0;
                label7.Text = score.ToString();
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            label1.Hide();
            label11.Hide();
        }

        public void Plane_fly()
        {
            while (single_stop)
            {
                lock (thislock)
                {
                    pictureBox2.Location = new System.Drawing.Point(pictureBox2.Location.X + 6, pictureBox2.Location.Y);
                    Thread.Sleep(10);
                    if (pictureBox2.Location.X > this.Size.Width)
                    {
                        pictureBox2.Location = new System.Drawing.Point(-100, pictureBox2.Location.Y);
                    }
                }
                
            }
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            System.Environment.Exit(0);
        }

        private void NewBullet(Bullet b)
        {
            b.X = pictureBox1.Location.X;
            b.Y = pictureBox1.Location.Y;
        }

        private void NewBulletfe(Bullet b)
        {
            b.X = pictureBox2.Location.X;
            b.Y = pictureBox2.Location.Y;
        }

        private void Shot(object b)
        {
            Bullet bullet = b as Bullet;
            Graphics g = this.CreateGraphics();
            while (true)
            {
                lock (thislock)
                {
                    bullet.Draw(g);
                    bullet.Move();
                    Thread.Sleep(10);
                    if (bullet.Y < -20) break;
                    //子弹碰到了
                    if ((Math.Abs(bullet.X - pictureBox2.Location.X) < 40) && (Math.Abs(bullet.Y - pictureBox2.Location.Y) < 40))
                    {
                        SoundPlayer player = new SoundPlayer(Resources.boom);
                        player.Play();
                        score++;
                        label7.Text = score.ToString();

                        if (isShot && label9.Text!=string.Empty)//每个子弹击中,HP槽减少
                        {
                            isShot = false;
                            label9.Text = label9.Text.Remove(label9.Text.Length-1);

                            Bullet bulletfe = new Bullet(); ;
                            NewBulletfe(bulletfe);
                            Thread t3 = new Thread(new ParameterizedThreadStart(Shot_enemy));
                            t3.Start(bulletfe);
                            isShotfe = true;
                        }
                    }
                }
            }
        }

        private void Shot_enemy(object b)
        {
            Bullet bullet = b as Bullet;
            Graphics g = this.CreateGraphics();
            while (true)
            {
                lock (thislock)
                {
                    bullet.Drawfe(g);
                    bullet.Movefe();
                    Thread.Sleep(10);
                    if (bullet.Y > this.Height) break;
                    //子弹碰到了
                    if ((Math.Abs(bullet.X - pictureBox1.Location.X) < 30) && (Math.Abs(bullet.Y - pictureBox1.Location.Y) < 30))
                    {
                        SoundPlayer player = new SoundPlayer(Resources.boom);
                        player.Play();

                        if (isShotfe && label13.Text != string.Empty)//被每个敌人的子弹击中,HP槽减少
                        {
                            isShotfe = false;
                            label13.Text = label13.Text.Remove(label13.Text.Length - 2);
                        }
                    }
                }
            }
        }

    }
}
